﻿namespace EJGrid.Models
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web;
    using EJGrid.Models;
    using System.Data.SqlClient;
    using System.Data;

    
    public static class OrderRepository
    {
        public static IList<EditableOrder> GetAllRecords1()
        {
            IList<EditableOrder> orders = (IList<EditableOrder>)HttpContext.Current.Session["Orders"];

            if (orders == null)
            {
                HttpContext.Current.Session["Orders"] = orders = (from ord in new NorthwindDataContext().EmployeeViews.Take(20)
                                                                  select new EditableOrder
                                                                  {
                                                                      City=ord.City,
                                                                       Country =ord.Country, 
                                                                        EmployeeID=ord.EmployeeID,
                                                                         FirstName=ord.FirstName,
                                                                          Title=ord.Title
                                                                  }).ToList();
            }
            return orders;
        }
        public static IList<EditableOrder2> GetAllRecords2()
        {
            IList<EditableOrder2> orders = (IList<EditableOrder2>)HttpContext.Current.Session["Orders2"];

            if (orders == null)
            {
                HttpContext.Current.Session["Orders2"] = orders = (from ord in new NorthwindDataContext().OrdersViews.Take(50)
                                                                  select new EditableOrder2
                                                                  {
                                                                      EmployeeID=ord.EmployeeID,
                                                                        CompanyName =ord.CompanyName,
                                                                         CustomerID =ord.CustomerID,
                                                                          OrderID=ord.OrderID,
                                                                           ShipCity=ord.ShipCity
                                                                  }).ToList();
            }
            return orders;
        }

        public static void Add(EditableOrder order)
        {
            GetAllRecords1().Insert(0, order);
        }

        public static void Delete(int order)
        {
            EditableOrder result = GetAllRecords1().Where(o => o.EmployeeID == order).FirstOrDefault();
                GetAllRecords1().Remove(result);
            
        }

        public static void Update(EditableOrder order)
        {
                EditableOrder result = GetAllRecords1().Where(o => o.EmployeeID == order.EmployeeID).FirstOrDefault();
                if (result != null)
                {
                    result.EmployeeID = order.EmployeeID;
                    result.FirstName = order.FirstName;
                    result.Title = order.Title;
                    result.Country = order.Country;
                    result.City = order.City;
                }
        }
        public static void ChildAdd(EditableOrder2 order)
        {
            GetAllRecords2().Insert(0, order);
        }

        public static void ChildDelete(int order)
        {
                EditableOrder2 result = GetAllRecords2().Where(o => o.OrderID == order).FirstOrDefault();
                GetAllRecords2().Remove(result);
            
        }

        public static void ChildUpdate(EditableOrder2 order)
        {
                EditableOrder2 result = GetAllRecords2().Where(o => o.OrderID == order.OrderID).FirstOrDefault();
                if (result != null)
                {
                    result.OrderID = order.OrderID;
                    result.ShipCity = order.ShipCity;
                    result.CustomerID = order.CustomerID;
                    result.CompanyName = order.CompanyName;
                }
            
        }
        
    }
}
